/*
 * Copyright 2017 Collective Financial Services Inc.
 */
package web.base.data

import scala.scalajs.js
import scala.scalajs.js.|

//============================ USER related stuff ====================

@js.native
trait UserFrag extends js.Object {
  val id: String
  val firstName: String
  val lastName: String
}

@js.native
trait FullUserFrag extends js.Object {
  val roles: js.Array[String]
  val permissions: js.Array[String]
  val user: UserFrag
}

@js.native
trait ViewerFrag extends BaseId {
  val id: String
  val user: FullUserFrag | Null
  val policies: SangriaConnection[PolicyFrag]
  val changes: SangriaConnection[ProposedChangeFrag]
  val claims: SangriaConnection[ClaimFrag]
}

@js.native
trait BaseViewerFrag extends js.Object {
  val viewer: ViewerFrag
  val node: js.Object
}

@js.native
trait ProposedChangesViewerFrag extends ViewerFrag {
  // Rethinking this a bit
}

@js.native
trait ProposedChangesFrag extends BaseViewerFrag {
  //  override val viewer:
  override val viewer: ProposedChangesViewerFrag
}

trait BaseId extends js.Object {
  val id: String
  val rawId: String
}
