package web.cps

import google.maps.LatLng
import google.react.{GoogleMaps => G}
import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._
import web.base.all._
import web.cps.AddressInputMap.MarkerHelper

object AddressMap {

  case class Props(boundsChange: Callback,
                   mapMounted: google.maps.Map => Callback,
                   center: LatLng,
                   markers: Seq[MarkerHelper])

  private val _C = ScalaComponent
    .builder[Props]("AddressMap")
    .stateless
    .render { bs =>
      val p = bs.props

      G.GoogleMap(new G.GoogleMap.Opt {
        override val defaultZoom = 15
        val center               = p.center
        val onBoundsChanged      = p.boundsChange.toJsFn
        override val ref         = p.mapMounted.toJsCallback
      })(p.markers.map { marker =>
        G.Marker.C.withKey(marker.title)(new G.Marker.Opt {
          val position       = marker.position
          override val title = marker.title
        })()
      }.toVdomArray)

    }
    .build

  val C = G.create(_C)

  def apply(p: Props, containerElement: VdomElement, mapElement: VdomElement): C.Unmounted = {
    C.withRawProp("containerElement", containerElement.rawElement)
      .withRawProp("mapElement", mapElement.rawElement)
      .applyGeneric(p)()
  }

}
