package web.cps

import ant.cps.{Col, Row}
import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._

object BareCard {

  case class Props(title: Option[VdomNode] = None, hdrLeft: VdomNode, hdrRight: VdomNode)

  object Props {
    def apply(title: VdomNode, hdrLeft: VdomNode, hdrRight: VdomNode): Props = Props(Some(title), hdrLeft, hdrRight)
  }

  // dduas
  val C = ScalaComponent
    .builder[Props]("BareCard")
    .stateless
    .render_PC { (p, pc) =>
      <.div(^.className := bareLo("bcard"))(
        Row(justify = "space-between", align = "middle", className = "header", `type` = "flex")(
          Col(Col.Opt)(p.hdrLeft),
          Col(new Col.Opt {
            override val span = 12
          })(<.h3(p.hdrRight))),
        <.div(^.className := "body")(
          p.title.map(t => <.div(^.className := "bare-heading")(t)).whenDefined,
          <.div(^.className := "bare-content")(pc),
        ))
    }
    .build
}
