package web.cps

import ant.cps.Form
import ant.cps.Form.{FormFacade, FormProps, Item}
import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._
import rmi.ReactMaskedInput
import shared.models.Flds
import web.base.all._

import scala.scalajs.js

object FormMaskedInput {

  case class Props(form: FormProps, name: String, inputOpts: ReactMaskedInput.Opts, itemOpts: Form.Item.Opt)

  class Backend(val $ : BackendScope[Props, Unit]) extends FormFacade {
    def form = $.props.runNow().form

    def willMount = $.props.map { p =>
      // Do the 2 way databind
      form.getFieldDecorator(p.name); ()
    }

    val onChg: js.Function1[ReactKeyboardEventFromInput, Unit] = { ri =>
      val value = ri.target.value
      if (!value.contains("_")) {
        setFieldsTouched($.props.runNow().name -> value)
      }
      ()
    }

    def render(p: Props) = {
      val error = form.getFieldError(p.name)
      Item(p.itemOpts.merge(new Item.Opt {
        override val validateStatus = if (error.isDefined) "error" else "success"
        override val help           = error.map(_.toString)
      }))(
        ReactMaskedInput(
          p.inputOpts
            .mergeLeftType(new js.Object {
              val className = "ant-input ant-input-lg"
              val value     = form.getFieldValue(p.name)
              val onChange  = onChg
            })
            .ex(^.width := "175px")))
    }
  }
  val C = ScalaComponent
    .builder[Props]("FormInputMasked")
    .stateless
    .renderBackend[Backend]
    .componentWillMount(_.backend.willMount)
    .build
}
