package web.cps

import ant.cps.Form.FieldOptions
import ant.cps.{Form, Switch}
import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._
import web.base.all._

import scala.scalajs.js

object IntSwitch {
  //
  class Props(val form: Form.FormProps, val name: String, val opts: Switch.Opt, val on: Int, val off: Int)
  val C = ScalaComponent
    .builder[Props]("IntSwitch")
    .stateless
    .render_P { p =>
      val onCheck: js.Function1[Boolean, Unit] = { b =>
        val v = if (b) p.on else p.off
        p.form.setFields(js.Dictionary(p.name -> new FieldOptions {
          override val touched = true
          override val value   = v
        }))
      }
      val fieldValue = p.form.getFieldValue(p.name).asInstanceOf[js.UndefOr[Int]].map(_ == p.on)

      Switch(p.opts.mergeLeftType(new Switch.Opt {
        override val onChange       = onCheck
        override val defaultChecked = fieldValue
      }))
    }
    .componentWillMount(f =>
      Callback {
        f.props.form.getFieldDecorator(f.props.name)
    })
    .build
}
