package web.cps.a1quote

import ant.cps.Form.{FormBackend, FormFacade, FormProps, Item}
import ant.cps.FormCreate.TypedFieldOptions
import ant.cps.{Form, FormCreate, Input}
import japgolly.scalajs.react._
import monix.reactive.subjects.PublishSubject
import org.scalajs.dom
import relay.runtime.store.RelayEnvironment
import shared.models.a1.{FieldKey => Fk}
import vdom.html_<^._
import web.cps.style
import web.views.Clean

import scala.scalajs.js

object QuoteA1Page2 {
  case class Props(f: TypedFrag[QuoteA1Frag],
                   env: RelayEnvironment,
                   queue: PublishSubject[(Fk[_], TypedFieldOptions[js.Any])])

  class Backend(val $ : BackendScope[Props, Unit]) extends FormBackend {

    def render(p: Props) = {
      Form(new Form.Opt {
        override val layout = "horizontal"
      })(
        <.div(^.marginBottom := "20px", ^.textAlign.center)(
          <.h1("Almost there!"),
          <.p("Fill out your personal details to bind the policy.")),
        Clean.Row(
          Item(style.respItem("First Name"))(getFieldDecorator("first_name")(Input(placeholder = "First Name"))),
          Item(style.respItem("Last Name"))(getFieldDecorator("last_name")(Input(placeholder   = "Last Name"))),
          Item(style.respItem("Email address"))(getFieldDecorator("email")(Input(placeholder   = "email address")))))
    }
  }

  val C = ScalaComponent.builder[Props]("QP2").stateless.renderBackend[Backend].build

  val FormC = FormCreate
    .builder[js.Dictionary[TypedFieldOptions[js.Any]]](C)
    .build

}
