package web.cps.a1quote
import ant.cps.Form.FormComponent.RuleOpt
import ant.cps.{Alert, Form, Input}
import ant.cps.Form.{FormComponent, FormFacade, FormProps}
import japgolly.scalajs.react._
import japgolly.scalajs.react.vdom.html_<^._
import shared.models.a1.{FieldKey => Fk}
import web.base.data.{FullUserFrag, ViewerFrag}
import web.cps.a1quote.QuoteParent.CProps
import web.cps.bareLo
import web.base.all._
import web.cps.a1quote.Step1.style

import scala.scalajs.js
import scala.scalajs.js.JSON

object QuoteLoggedIn {
  case class State(doLogin: Boolean)
  case class Props(vf: OrNull[ViewerFrag], form: FormProps, newAccountShownCallback: Boolean => Callback)
  val C = ScalaComponent
    .builder[Props]("QuoteLoggedInPane")
    .initialStateFromProps(f => State(doLogin = f.vf.isEmpty))
    .renderBackend[Backend]
    .build

  class Backend(val $ : BackendScope[Props, State]) extends FormFacade {

    def form: FormProps = $.props.runNow().form

    def loggedIn(fu: FullUserFrag, p: Props) = {
      p.newAccountShownCallback(false).runNow()
      <.div(
        Alert(
          `type` = "info",
          message = <.p(
            """It looks like you're logged in, if your first name is """,
            <.strong(fu.user.firstName),
            " and you'd like to continue, just click the next button.").rawNode))
    }

    def emptyAccount(p: Props) = {
      p.newAccountShownCallback(true).runNow()
      <.div(
        FormCtl.splitRow(^.marginTop := "0px")(
          Form.Item(style.fullItem("Email"))(getFieldDecorator(Fk.Email, new FormComponent.Opt {
            override val validateTrigger = "onBlur"
            override val rules =
              js.defined(js.Array(RuleOpt(`type` = "email", required = true, message = "Please enter a valid email")))
          })(Input(placeholder = "me@domain.com")))),
        FormCtl.splitRow(^.marginTop := "0px")(
          Form.Item(style.fullItem("Password"))(getFieldDecorator(Fk.Password, new FormComponent.Opt {
            override val validateTrigger = "onBlur"
            override val rules           = js.defined(js.Array(RuleOpt(required = true, message = "Please enter a password")))
          })(Input(placeholder = "Something Nice and Long", `type` = "password"))),
          Form.Item(style.fullItem("Confirm Password"))(getFieldDecorator(Fk.Password2, new FormComponent.Opt {
            override val validateTrigger = "onBlur"
            override val rules = js.defined(js.Array(new RuleOpt {
              val required: Boolean = true
              override val validator = js.defined { (rule, value, cb) =>
                if (getFieldValue[String](Fk.Password).exists(_ == value))
                  cb(js.undefined)
                else cb("Passwords must be the same")
              }
            }))
          })(Input(placeholder = "The Same Thing", `type` = "password")))))
    }

    def render(p: Props, s: State) = {
      <.div(
        <.div(^.className := bareLo("header"))(
          <.h1("User Account"),
          <.p(
            "Choose how you'd like to login." //            p.vf
//              .flatMap(_.user)
//              .map(fu => <.span(" or attach to your current logged in account, ", <.em(fu.user.firstName)))
//              .toOption
//              .whenDefined
          ),
          p.vf.flatMap(_.user).map { fu =>
            loggedIn(fu, p)
          } getOrElse emptyAccount(p)))
    }
  }
}
