package web.cps.a1quote

import shared.models.a1.FieldKey
import web.base.data.{JsCoerce, LocalRateChecked}
import web.base.all._

import scala.scalajs.js
import scala.scalajs.js.UndefOr
import scala.scalajs.js.JSConverters._

class SimpleTypedFrag[T <: js.Object](val t: T) extends AnyVal {

  @inline def dyn: js.Dynamic = t.asInstanceOf[js.Dynamic]

  def apply[T1](fk: FieldKey[T1])(implicit toJsTyp: JsCoerce[T1]): js.UndefOr[T1] = {
    dyn.selectDynamic(fk.value).asInstanceOf[UndefOr[js.Any]].flatMap { f =>
      toJsTyp.convert(f).orUndefined
    }
  }

  def opt[T1](fk: FieldKey[Option[T1]])(implicit toJsTyp: JsCoerce[T1]): js.UndefOr[T1] = {
    dyn.selectDynamic(fk.value).asInstanceOf[UndefOr[js.Any]].flatMap { f =>
      toJsTyp.convert(f).orUndefined
    }
  }
}
