package web.mutation

import dispalt.relay.gql
import org.scalajs.dom
import relay.graphql.TaggedNode
import relay.raw.Relay
import relay.runtime.RecordSourceSelectorProxy
import relay.runtime.RelayRuntime.{ConnectionHandler, ViewerHandler}
import relay.runtime.mutation.{CommitMutation, MutationConfig, MutationInput}
import relay.runtime.store.RelayEnvironment
import web.base.data.LocalRelayError
import web.base.all._

import scala.scalajs.js.JSConverters._
import scala.scalajs.js

object CancelChangeMutation {

  @gql("""
    mutation CancelChangeMutation($input: CancelChangeInput!) {
      cancelChange(input: $input) {
        clientMutationId
        deletedIds
        viewer {
          id
        }
      }
    }
  """)
  object mut extends TaggedNode

  import js.Dynamic.literal

  def commit(env: RelayEnvironment, viewerId: String, v: Seq[String]) = {
    CommitMutation[js.Dynamic, js.Object](env,
                                          relay.generated.CancelChangeMutation.query,
                                          literal(ids = v.toJSArray),
                                          update = Some { rsp: RecordSourceSelectorProxy =>
                                            for {
//          viewer <- rsp.get(ViewerHandler.VIEWER_ID)
                                              viewer  <- rsp.get(viewerId)
                                              conn    <- ConnectionHandler.getConnection(viewer, "NameSettings_changes")
                                              payload <- rsp.getRootField("cancelChange")
                                            } yield {
                                              val value = payload.getValueV[js.Array[String]]("deletedIds")
                                              value.foreach(id => ConnectionHandler.deleteNode(conn, id))
                                            }; ()
                                          }).map(_.left.map(LocalRelayError(_)))
  }
}
