package web.mutation

import dispalt.relay.gql
import monix.eval.Task
import monix.execution.CancelableFuture
import org.scalajs.dom
import relay.runtime.{RecordSourceProxy, RecordSourceSelectorProxy, RelayRuntime}
import relay.runtime.mutation.{CommitMutation, MutationConfig, MutationInput}
import relay.runtime.store.RelayEnvironment
import web.base.data.LocalRelayError
import web.base.all._

import scala.scalajs.js.Dynamic.literal
import scala.scalajs.js

object LogoutMutation {

  @gql("""
    mutation LogoutMutation(
      $input: LogoutInput!
    ) {
      logout(input: $input) {
        clientMutationId
        viewerId
      }
    }
  """)
  object mut extends js.Object

  //

  def commit(viewerId: String, env: RelayEnvironment): Task[Either[LocalRelayError, js.Object]] = {
    val updater = Some { rsp: RecordSourceSelectorProxy =>
      rsp.delete(viewerId)
      ()
    }

    CommitMutation[js.Object, js.Object](env, relay.generated.LogoutMutation, new js.Object(), updater)
      .map(_.left.map(LocalRelayError(_)))
  }

}
