package web.admin.cps

import ant.cps.{Button, Card, Icon, Table}
import dispalt.relay.gql
import japgolly.scalajs.react._
import japgolly.scalajs.react.extra.router.RouterCtl
import moment.Moment
import org.scalajs.dom
import relay.components._
import vdom.html_<^._
import web.admin.data.{BaseViewerFrag, OperatorReviewPendingFrag}
import web.admin.mutation.ChangeReviewedMutation
import web.admin.routes.Page
import web.base.data.SangriaEdge
import web.base.all._
import web.react.RelayBackend

import scala.scalajs.js

object OperatorReviewList {
  //
  override def toString = "[OperatorReviewList]"

  val C = ScalaComponent
    .builder[Unit]("OperatorReviewList")
    .stateless
    .noBackend
    .render { p =>
      val rb = p.relayBackend[BaseViewerFrag]
      dom.console.log(rb.relayProps)

      def clickCheck(_id: String, _userId: String, _approve: Boolean) = Callback {
        ChangeReviewedMutation.commit(rb.relay.environment, rb.relayProps.viewer.id, new ChangeReviewedMutation.Input {
          val userId  = _userId
          val approve = _approve
          val id      = _id
        })
      }

      Card(new Card.Opts {
        override val title     = "Awaiting Approvals Appropo"
        override val className = "card-thck"
      })(Table(new Table.Opts[SangriaEdge[OperatorReviewPendingFrag]] {
        override val size = "small"
        val dataSource    = rb.relayProps.viewer.approvals.edges

        // TODO: Clean this up
        override val rowKey = js.defined({ (r: SangriaEdge[OperatorReviewPendingFrag]) =>
          r.node.id
        }: js.Function1[SangriaEdge[OperatorReviewPendingFrag], String])

        val columns: js.Array[Table.ColumnProps[SangriaEdge[OperatorReviewPendingFrag]]] =
          js.Array(Table.ColumnProps(title = "Id", dataIndex = "node.rawId", render = js.defined { (f, rec, _) =>
            <.code(rec.node.rawId).rawNode
          }), Table.ColumnProps(title = "Details", dataIndex = "node.id", render = js.defined { (f, rec, n) =>
            //
            val res: Option[VdomNode] = for {
              pc <- rec.node.pc.toOption
              af <- pc.after.toGMsg
              be <- pc.before.toGMsg
            } yield {
              <.div(<.div(<.code(s"Before :: ${af.getClass.getSimpleName}")),
                    <.div(be.toString),
                    <.div(<.code("After")),
                    <.div(af.toString))
            }
            val disp = res.getOrElse[VdomNode]("Failed to parse details")
            disp.rawNode
          }), Table.ColumnProps(title = "When", render = js.defined { (f, rec, n) =>
            Moment(rec.node.when).fromNow()
          }), Table.ColumnProps(title = "User", render = js.defined { (f, rec, _) =>
            rec.node.userId.rawNode
          //
          }), Table.ColumnProps(title = "Approve?", render = js.defined { (f, rec, n) =>
            <.div(
              Button(`type` = "ghost", onClick = clickCheck(rec.node.rawId, rec.node.userId, _approve = false).toJsFn1)(
                Icon("close")),
              " ",
              Button(
                `type` = "primary",
                onClick = clickCheck(rec.node.rawId, rec.node.userId, _approve = true).toJsFn1)(Icon("check"))).rawNode
          }))
      }))
    }
    .buildRelay[BaseViewerFrag]

  @gql("""
    fragment OperatorReviewList_viewer on Viewer {
      id
      approvals(after: $after, first: $first) @connection(key: "Pending_approvals")  {
        edges {
          node {
            id
            rawId
            userId
            fullUser {
              id
              user {
                firstName
              }
            }
            when
            pc {
              id
              before
              after
            }
          }
          cursor
        }
        pageInfo {
          hasNextPage
          endCursor
        }
      }
    }
  """)
  object ppc_viewer extends TaggedNode

  val Container = FragmentContainer.buildRelay(C, "viewer" -> ppc_viewer)
}
