package web.admin.data

import shared.proto.party.PartyEvent
import web.base.data._

import scala.scalajs.js
import scala.scalajs.js.annotation.ScalaJSDefined
import scala.scalajs.js.|

@js.native
trait UserFrag extends js.Object {
  val id: String
  val firstName: String
  val lastName: String
  val email: String
  val timeCreatedMs: Double
}

@js.native
trait FullUserFrag extends js.Object {
  val id: String
  val rawId: String
  val roles: js.Array[String]
  val permissions: js.Array[String]
  val user: UserFrag
  val policies: SangriaConnection[PolicyFrag]
  val partyEvents: SangriaConnection[PartyEventLogFrag]
}

@js.native
trait OperatorReviewPendingFrag extends js.Object {
  val id: String
  val rawId: String
  val userId: String
  val fullUser: FullUserFrag
  val when: Double
  val pc: ProposedChangeFrag | Null
}

/////////////////////
// Transitioning to a better setup
@js.native
trait ViewerFrag extends js.Object {
  val user: FullUserFrag | Null
  val id: String
  val approvals: SangriaConnection[OperatorReviewPendingFrag]
  val users: SangriaConnection[FullUserFrag]
  val operatorsLive: SangriaConnection[FullUserFrag]
  val policies: SangriaConnection[PolicyFrag]
}

//////////////////
// TopLevel
//  - Defined as SJS Defined classes because then I can inherit and instantiate them.
/////////////
trait BaseViewerFrag extends js.Object {
  val viewer: ViewerFrag

  /** Specifically dealing with a search for an object */
  val node: js.Object
}
