package web.admin.mutation

import dispalt.relay.gql
import relay.runtime.RecordSourceSelectorProxy
import relay.runtime.RelayRuntime.{ConnectionHandler, ViewerHandler}
import relay.runtime.mutation.{CommitMutation, MutationInput}
import relay.runtime.store.RelayEnvironment

import web.base.all._

import scala.scalajs.js
import scala.scalajs.js.annotation.ScalaJSDefined

object ChangeReviewedMutation {
  //

  trait Input extends js.Object {
    val id: String
    val userId: String
    val approve: Boolean
    val details: js.UndefOr[String] = js.undefined
  }

  type V = Input
  type R = js.Object

  @gql("""
          mutation ChangeReviewedMutation(
            $input: ChangeReviewedInput!
          ) {
            changeReviewed(input: $input) {
              clientMutationId,
              completedReviewedID
            }
          }
      """)
  object changereviewedmutation extends TaggedNode

  def commit(env: RelayEnvironment, viewerId: String, vars: V) = {
    CommitMutation[V, js.Object](env, changereviewedmutation, vars, Some { rsp: RecordSourceSelectorProxy =>
      for {
        payload <- rsp.getRootField("changeReviewed")
        viewer  <- rsp.get(viewerId)
        conn    <- ConnectionHandler.getConnection(viewer, "Pending_approvals")
      } yield {
        ConnectionHandler.deleteNode(conn, payload.getValueStr("completedReviewedID"))
      }; ()
      ()
    })
  }
}
